﻿namespace HeuristicLab.Algorithms.PushGP.Stack {
  using System;
  using System.Collections.Generic;

  public interface IStack<T> : ICollection<T> {
    bool IsEmpty { get; }

    T Top { get; }

    T TopOrDefault { get; }

    T Bottom { get; }

    T BottomOrDefault { get; }

    T this[int key] { get; set; }

    void Swap(int count);

    void Yank(int index);

    void Push(T item);

    void Push(params T[] items);

    void Push(IEnumerable<T> items);

    void PushResult(int count, Func<T[], T> templateFunc);

    void Insert(int index, T item);

    void Insert(int index, params T[] items);

    void Insert(int index, IEnumerable<T> items);

    T ReverseElementAt(int offset);

    void SetTop(T value);

    void RemoveTop();

    void Remove(int count);

    void RemoveAt(int index);

    void RemoveAt(int index, int count);

    T Pop();

    T[] Pop(int count);

    bool TryPop(out T item);

    T ElementAt(int index);
  }
}